package app.service.impl;

import javax.annotation.Resource;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import app.dao.Test1Dao;
import app.entity.Test1Entity;
import app.exception.TestException;
import app.service.Test1Service;
import app.service.Test2Service;

public class Test1ServiceImpl implements Test1Service {

	private static Log LOG = LogFactory.getLog(Test1ServiceImpl.class);

	@Resource
	private Test1Dao test1Dao;

	@Resource
	private Test2Service test2Service;

	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public int getCount() {
		return this.test1Dao.getCount();
	}

	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public void requiredRequired_1(Test1Entity test1Entity) {
		this.test1Dao.insert(test1Entity);

		this.test2Service.requiredRequired_2(test1Entity);
	}

	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public void requiredRequiredRollback_1(Test1Entity test1Entity) {
		this.test1Dao.insert(test1Entity);

		this.test2Service.requiredRequiredRollback_2(test1Entity);
	}

	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public void requiredRequiresNew_1(Test1Entity test1Entity) {
		this.test1Dao.insert(test1Entity);

		this.test2Service.requiredRequiresNew_2(test1Entity);
	}

	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public void requiredRequiresNewRollback1_1_1(Test1Entity test1Entity) {
		this.test1Dao.insert(test1Entity);

		try {
			this.test2Service.requiredRequiresNewRollback1_1_2(test1Entity);
		} catch (Exception e) {
			LOG.info("gUNV[obN̂߂̎OLb`ăX[Ȃ");
		}
	}

	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public void requiredRequiresNewRollback1_2_1(Test1Entity test1Entity) {
		this.test1Dao.insert(test1Entity);

		try {
			this.test2Service.requiredRequiresNewRollback1_2_2(test1Entity);
		} catch (Exception e) {
			LOG.info("gUNV[obN̂߂̎OLb`ăX[Ȃ");
		}
	}	
	
	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public void requiredRequiresNewRollback2_1(Test1Entity test1Entity) {
		this.test1Dao.insert(test1Entity);

		this.test2Service.requiredRequiresNewRollback2_2(test1Entity);

		throw new TestException("gUNV[obN̂߂̎O");
	}

	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public void requiredRequiresNewRollback3_1(Test1Entity test1Entity) {
		this.test1Dao.insert(test1Entity);

		this.test2Service.requiredRequiresNewRollback3_2(test1Entity);

		throw new TestException("gUNV[obN̂߂̎O");
	}

}
